Attribute VB_Name = "Module_MySafeRename"
Option Explicit
'############################################################################################
Public Sub MySafeRename(SourcePath As String, TargetPath As String, cFileName As String)
On Error Resume Next
    Dim SrcFile0 As String
    Dim SrcFile1 As String
    Dim TrgFile0 As String
    Dim TrgFile1 As String
    Dim Col_Name As String
    Dim Fi_Name As String
    Dim Fi_Exte As String
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (Dir(SourcePath, vbDirectory) = "") Then
        'MsgBox "Folder: " & SourcePath & "Not Found", vbCritical
        Exit Sub
    End If
    If (Dir(TargetPath, vbDirectory) = "") Then
        'MsgBox "Folder: " & SourcePath & "Not Found", vbCritical
        Exit Sub
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Fi_Name = F_Name(cFileName)
    Fi_Exte = F_Exte(cFileName)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (Fi_Exte <> ".q0") Then
        SrcFile0 = SourcePath & "\" & Fi_Name & Fi_Exte
        TrgFile0 = TargetPath & "\" & Fi_Name & Fi_Exte
        Col_Name = LCase(Fi_Name)
Loop1:
        If (Dir(TrgFile0) = "") Then
            Name SrcFile0 As TrgFile0
        Else
            Col_Name = LCase(MyMakeTag)
            TrgFile0 = TargetPath & "\" & Col_Name & Fi_Exte
            GoTo Loop1
        End If
    End If
    'Exit Sub
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If (Fi_Exte = ".q0") Then
        SrcFile0 = SourcePath & "\" & Fi_Name & ".q0"
        TrgFile0 = TargetPath & "\" & Fi_Name & ".q0"
        SrcFile1 = SourcePath & "\" & Fi_Name & ".q1"
        TrgFile1 = TargetPath & "\" & Fi_Name & ".q1"
        Col_Name = LCase(Fi_Name)
Loop2:
        'If ((Dir(TrgFile0) = "") And (Dir(TrgFile1) = "")) Then
        'Modified 2002/06/01 to "statistically" circumvent the bug in Reliable
            'If Reliable cannot post and there is already a "wwwwww.qo" in \Error 
            '... we land in serious trouble, .OCX in lock state ....a mess
        If ((Dir(TrgFile0) = "") And (Dir(TrgFile1) = "") And (Col_Name <> "wwwwww")) Then
            Name SrcFile0 As TrgFile0
            Name SrcFile1 As TrgFile1
        Else
            Col_Name = LCase(MyMakeTag)
            TrgFile0 = TargetPath & "\" & Col_Name & ".q0"
            TrgFile1 = TargetPath & "\" & Col_Name & ".q1"
            GoTo Loop2
        End If
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################
'############################################################################################
Private Function MyMakeTag() As String
    Const K = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"
    Dim i As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    MyMakeTag = "~COL"
    For i = 5 To 8
        MyMakeTag = MyMakeTag & Mid(K, Int(Rnd(1) * 36) + 1, 1)
    Next i
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Private Function F_Name(cFileName As String) As String
    Dim i As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    i = InStr(1, cFileName, ".")
    If (i = 0) Then
        F_Name = LCase(cFileName)
    Else
        F_Name = LCase(Left(cFileName, i - 1))
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Private Function F_Exte(cFileName As String) As String
    Dim i As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    i = InStr(1, cFileName, ".")
    If (i = 0) Then
        F_Exte = ""
    Else
        F_Exte = LCase(Right(cFileName, Len(cFileName) - i + 1))
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################

